"use strict";

var filter = {
  urls: ["https://mail.yahoo.com/*"],
  types: ["sub_frame"],
};

browser.webRequest.onBeforeSendHeaders.addListener(
  rewriteOrRemoveHeader, filter, [
    "blocking",
    "requestHeaders",
  ]
);

browser.webRequest.onHeadersReceived.addListener(
  rewriteOrRemoveHeader, filter, [
    "blocking",
    "responseHeaders",
  ]
);

function rewriteOrRemoveHeader(details) {
  if (details.documentUrl == browser.extension.getURL('popup.html')) {
    if (details.responseHeaders) {
      if (details.statusCode == 200) {
        let filter = browser.webRequest.filterResponseData(details.requestId);

        filter.onerror = event => {
          console.log(filter.error);
        };

        filter.ondata = event => {
          filter.write(event.data);
          console.log(event.data);
        };

        filter.onstop = event => {
          filter.close();
        };
      }
    }
    else if (details.requestHeaders) {
      let {requestHeaders} = details;
      for (let i = 0; i < requestHeaders.length; i++) {
        if (requestHeaders[i].name.toLowerCase() == "user-agent") {
          requestHeaders[i].value = "Mozilla/5.0 (Android 9; Mobile; rv:68.0) Gecko/68.0 Firefox/68.0";
          break;
        }
      }
      return { requestHeaders };
    }
  }
}
